%bcond_with check

Summary:        RPM macros and generators for building Rust packages
Name:           rust-packaging
Version:        26.1
Release:        1%{?dist}
License:        MIT
URL:            https://pagure.io/fedora-rust/rust-packaging
Source0:        %{url}/archive/%{version}/rust-packaging-%{version}.tar.gz
# Temporarily accept cargo_prep -V flag for spec compatibiltiy
Patch3000:      0001-Temporarily-accept-cargo_prep-V-flag-for-spec-compat.patch

BuildArch:      noarch

%if %{with check}
BuildRequires:  python3-pytest
%endif

%description
RPM macros and generators for building Rust packages


%package -n rust-srpm-macros
Summary:        RPM macros for building Rust projects

%description -n rust-srpm-macros
RPM macros for building source packages for Rust projects.


%package -n cargo-rpm-macros
Summary:        RPM macros for building projects with cargo

Requires:       cargo
Requires:       cargo2rpm >= 0.1.8
Requires:       gawk grep
Requires:       rust-srpm-macros = %{version}-%{release}

Provides:       rust-packaging = %{version}-%{release}

%description -n cargo-rpm-macros
RPM macros for building projects with cargo.

%prep
%autosetup -p1

%build

%install
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.cargo
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust-srpm
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo.attr
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo_vendor.attr

%if %{with check}
%check
export MACRO_DIR=%{buildroot}%{_rpmmacrodir}
pytest -vv
%endif

%files -n rust-srpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.rust
%{_rpmmacrodir}/macros.rust-srpm

%files -n cargo-rpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.cargo
%{_fileattrsdir}/cargo.attr
%{_fileattrsdir}/cargo_vendor.attr

%changelog
* Wed Feb 28 2024 Wang Guodong <gordonwwang@tencent.com> - 26.1-1
- Update to version 26.1
- Accept cargo_prep -V flag

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-6
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 18 2023 Wang Guodong <gordonwwang@tencent.com> - 24-5
- Rebuilt for rust 1.69.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 23 2023 Yi Lin <nilusyi@tencent.com> - 24-2
- add provides rust-packaging.

* Wed Mar 22 2023 Yi Lin <nilusyi@tencent.com> - 24-1
- package init.
